linux/scripts/link-vmlinux.sh
<<
>>
Prefs
   1#!/bin/sh
   2#
   3# link vmlinux
   4#
   5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
   6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
   7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
   8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
   9#
  10# vmlinux
  11#   ^
  12#   |
  13#   +-< $(KBUILD_VMLINUX_INIT)
  14#   |   +--< init/version.o + more
  15#   |
  16#   +--< $(KBUILD_VMLINUX_MAIN)
  17#   |    +--< drivers/built-in.o mm/built-in.o + more
  18#   |
  19#   +-< ${kallsymso} (see description in KALLSYMS section)
  20#
  21# vmlinux version (uname -v) cannot be updated during normal
  22# descending-into-subdirs phase since we do not yet know if we need to
  23# update vmlinux.
  24# Therefore this step is delayed until just before final link of vmlinux.
  25#
  26# System.map is generated to document addresses of all kernel symbols
  27
  28# Error out on error
  29set -e
  30
  31# Nice output in kbuild format
  32# Will be supressed by "make -s"
  33info()
  34{
  35        if [ "${quiet}" != "silent_" ]; then
  36                printf "  %-7s %s\n" ${1} ${2}
  37        fi
  38}
  39
  40# Link of vmlinux.o used for section mismatch analysis
  41# ${1} output file
  42modpost_link()
  43{
  44        ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT}                   \
  45                --start-group ${KBUILD_VMLINUX_MAIN} --end-group
  46}
  47
  48# Link of vmlinux
  49# ${1} - optional extra .o files
  50# ${2} - output file
  51vmlinux_link()
  52{
  53        local lds="${objtree}/${KBUILD_LDS}"
  54
  55        if [ "${SRCARCH}" != "um" ]; then
  56                ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}                  \
  57                        -T ${lds} ${KBUILD_VMLINUX_INIT}                     \
  58                        --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
  59        else
  60                ${CC} ${CFLAGS_vmlinux} -o ${2}                              \
  61                        -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT}                 \
  62                        -Wl,--start-group                                    \
  63                                 ${KBUILD_VMLINUX_MAIN}                      \
  64                        -Wl,--end-group                                      \
  65                        -lutil ${1}
  66                rm -f linux
  67        fi
  68}
  69
  70
  71# Create ${2} .o file with all symbols from the ${1} object file
  72kallsyms()
  73{
  74        info KSYM ${2}
  75        local kallsymopt;
  76
  77        if [ -n "${CONFIG_SYMBOL_PREFIX}" ]; then
  78                kallsymopt="${kallsymopt} \
  79                            --symbol-prefix=${CONFIG_SYMBOL_PREFIX}"
  80        fi
  81
  82        if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
  83                kallsymopt="${kallsymopt} --all-symbols"
  84        fi
  85
  86        local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
  87                      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
  88
  89        ${NM} -n ${1} | \
  90                scripts/kallsyms ${kallsymopt} | \
  91                ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
  92}
  93
  94# Create map file with all symbols from ${1}
  95# See mksymap for additional details
  96mksysmap()
  97{
  98        ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
  99}
 100
 101sortextable()
 102{
 103        ${objtree}/scripts/sortextable ${1}
 104}
 105
 106# Delete output files in case of error
 107trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
 108cleanup()
 109{
 110        rm -f .old_version
 111        rm -f .tmp_System.map
 112        rm -f .tmp_kallsyms*
 113        rm -f .tmp_version
 114        rm -f .tmp_vmlinux*
 115        rm -f System.map
 116        rm -f vmlinux
 117        rm -f vmlinux.o
 118}
 119
 120#
 121#
 122# Use "make V=1" to debug this script
 123case "${KBUILD_VERBOSE}" in
 124*1*)
 125        set -x
 126        ;;
 127esac
 128
 129if [ "$1" = "clean" ]; then
 130        cleanup
 131        exit 0
 132fi
 133
 134# We need access to CONFIG_ symbols
 135case "${KCONFIG_CONFIG}" in
 136*/*)
 137        . "${KCONFIG_CONFIG}"
 138        ;;
 139*)
 140        # Force using a file from the current directory
 141        . "./${KCONFIG_CONFIG}"
 142esac
 143
 144#link vmlinux.o
 145info LD vmlinux.o
 146modpost_link vmlinux.o
 147
 148# modpost vmlinux.o to check for section mismatches
 149${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
 150
 151# Update version
 152info GEN .version
 153if [ ! -r .version ]; then
 154        rm -f .version;
 155        echo 1 >.version;
 156else
 157        mv .version .old_version;
 158        expr 0$(cat .old_version) + 1 >.version;
 159fi;
 160
 161# final build of init/
 162${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
 163
 164kallsymso=""
 165kallsyms_vmlinux=""
 166if [ -n "${CONFIG_KALLSYMS}" ]; then
 167
 168        # kallsyms support
 169        # Generate section listing all symbols and add it into vmlinux
 170        # It's a three step process:
 171        # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
 172        #     but __kallsyms is empty.
 173        #     Running kallsyms on that gives us .tmp_kallsyms1.o with
 174        #     the right size
 175        # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
 176        #     the right size, but due to the added section, some
 177        #     addresses have shifted.
 178        #     From here, we generate a correct .tmp_kallsyms2.o
 179        # 2a) We may use an extra pass as this has been necessary to
 180        #     woraround some alignment related bugs.
 181        #     KALLSYMS_EXTRA_PASS=1 is used to trigger this.
 182        # 3)  The correct ${kallsymso} is linked into the final vmlinux.
 183        #
 184        # a)  Verify that the System.map from vmlinux matches the map from
 185        #     ${kallsymso}.
 186
 187        kallsymso=.tmp_kallsyms2.o
 188        kallsyms_vmlinux=.tmp_vmlinux2
 189
 190        # step 1
 191        vmlinux_link "" .tmp_vmlinux1
 192        kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
 193
 194        # step 2
 195        vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
 196        kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
 197
 198        # step 2a
 199        if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
 200                kallsymso=.tmp_kallsyms3.o
 201                kallsyms_vmlinux=.tmp_vmlinux3
 202
 203                vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
 204
 205                kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
 206        fi
 207fi
 208
 209info LD vmlinux
 210vmlinux_link "${kallsymso}" vmlinux
 211
 212if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
 213        info SORTEX vmlinux
 214        sortextable vmlinux
 215fi
 216
 217info SYSMAP System.map
 218mksysmap vmlinux System.map
 219
 220# step a (see comment above)
 221if [ -n "${CONFIG_KALLSYMS}" ]; then
 222        mksysmap ${kallsyms_vmlinux} .tmp_System.map
 223
 224        if ! cmp -s System.map .tmp_System.map; then
 225                echo >&2 Inconsistent kallsyms data
 226                echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
 227                cleanup
 228                exit 1
 229        fi
 230fi
 231
 232# We made a new kernel - delete old version file
 233rm -f .old_version
 234
lxr.linux.no kindly hosted by Redpill Linpro AS, provider of Linux consulting and operations services since 1995.